#include <boost/asio.hpp>
#include <boost/bind.hpp>
using namespace std;
using namespace boost;
using namespace boost::asio;
using ip::tcp;

class AddSession
{
    friend class AddServer;

    AddSession( io_service& io ) : sok(io) {}

    void start()
    {
        async_read_until( sok, buf, '\n',
          bind(&AddSession::read_ok,this,_1,_2) );
    }

    void read_ok( const boost::system::error_code& e, size_t siz )
    {
        if(e) { delete this; return; }

        std::iostream s(&buf);
        int x, y;
        s >> x >> y;
        s << x+y << endl;

        async_write( sok, buf, bind(&AddSession::write_ok,this,_1,_2) );
    }

    void write_ok( const boost::system::error_code& e, size_t siz )
    {
        delete this;
    }

    tcp::socket            sok;
    boost::asio::streambuf buf;
};

class AddServer
{
public:
    AddServer( io_service& io )
      : io(io), acc(io,tcp::endpoint(tcp::v4(), 10101))
      { start(); } // acceptJn

private:
    io_service&    io;
    tcp::acceptor acc;
    AddSession*   cur_session;

    void start()
    {
        cur_session = new AddSession(io);
        acc.async_accept( cur_session->sok, bind(&AddServer::accept_ok,this,_1) );
    }

    void accept_ok( const boost::system::error_code& e )
    {
        if(e) { delete cur_session; return; }
        cur_session->start();
        start();
    }
};

int main()
{
    io_service io;
    AddServer ads(io);

    io.run();
}
