#include <iostream>
#include <boost/serialization/serialization.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/string.hpp>
#include <fstream>
#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/text_oarchive.hpp>
using namespace std;
using namespace boost::archive;

class SaveData
{
public:
    SaveData() {}
    SaveData(int n, double p) : num(n), pi(p) {}
    void add(const string& s) { vec.push_back(s); }
    void print() {
        cout << vec.size() << " " << vec[0] << " " << vec[1] << endl;
        cout << num << endl;
        cout << pi << endl;
    }

private:
    vector<string> vec;
    int            num;
    double          pi;

////////////////// VACY̎ /////////////////////////
private:
    friend class boost::serialization::access;
    template<class Archive>
      void serialize( Archive& ar, unsigned int ver )
      {
          ar & vec;
          ar & num;
          ar & pi;
      }
};

int main()
{
    // ۑ
    {
        SaveData data(100, 3.14);
        data.add("Hello");
        data.add("World");

        ofstream file("save.dat");
        text_oarchive oa(file);
        oa << (const SaveData&) data;
    }

    // 
    {
        SaveData data;

        ifstream file("save.dat");
        text_iarchive ia(file);
        ia >> data;
        data.print();
    }
}
