#include <iostream>
#include <memory>
#include <typeinfo>
#include <boost/mpl/list.hpp>
#include <boost/mpl/push_front.hpp>
#include <boost/mpl/reverse.hpp>
#include <boost/mpl/replace.hpp>
#include <boost/mpl/for_each.hpp>
using namespace boost::mpl;

typedef list<bool, short, int, long>  Ints;

struct AddPtr {
    template<typename T>
      struct apply { typedef T* type; };
};

typedef transform< Ints, AddPtr >::type PtrInts;

typedef transform< Ints, std::auto_ptr<_> >::type AptrInts;

struct print_type {
  template<typename T>
    void operator()( const T& ) const
      { std::cout << typeid(T).name() << std::endl; }
};

int main()
{
    for_each<PtrInts>( print_type() );
    for_each<AptrInts>( print_type() );
    return 0;
}
