#include <boost/mpl/list.hpp>
#include <boost/mpl/fold.hpp>
#include <boost/mpl/transform_view.hpp>
#include <boost/mpl/find_if.hpp>
#include <boost/mpl/deref.hpp>
#include <boost/type_traits.hpp>
using namespace boost::mpl;

// [eBeB

template<typename T>
  struct tag {};
template<class D>
  struct base_of {
      template<class B>
      struct apply {
          typedef boost::is_base_and_derived<B,D> type;
      };
  };

// class abstract_factory< list<A,B,C> >
// {
// public:
//    virtual A* create( tag<A> ) = 0;
//    virtual B* create( tag<B> ) = 0;
//    virtual C* create( tag<C> ) = 0;
// };
// ̂悤ȃNX𐶐

template<class Base, typename T>
  struct a_creater {
      typedef struct _ : Base {
          using Base::create;
          virtual T* create( tag<T> ) = 0;
      } type;
  };
template<typename T>
  struct a_creater<void,T> {
      typedef struct _ {
          virtual T* create( tag<T> ) = 0;
      } type;
  };
template<typename TL>
  class abstract_factory
    : public fold< TL, void, a_creater<_,_> >::type {};

// class concrete_factory< list<A,B,C>, list<DA,DB,DC> >
// {
// public:
//    A* create( tag<A> ) { return DA; }
//    B* create( tag<B> ) { return DB; }
//    C* create( tag<C> ) { return DC; }
// };
// ̂悤ȃNX𐶐

template<class Base, typename T>
  struct c_creater
  {
      typedef typename T::first ATL;
      typedef typename T::second C;
      typedef typename deref<
        typename find_if< ATL, base_of<C> >::type>::type A;
      typedef struct _ : Base {
          using Base::create;
          A* create( tag<A> ) { return new C; }
      } type;
  };

template<typename ATL, typename CTL>
  class concrete_factory
    : public fold<
        transform_view< CTL, pair<ATL,_> >,
        abstract_factory<ATL>, c_creater<_,_>
      >::type {};

class A {}; class DA : public A {};
class B {}; class DB : public B {};
class C {}; class DC : public C {};

int main()
{
	typedef list<A,B,C>    ATL;
	typedef list<DA,DB,DC> CTL;

	abstract_factory<ATL>* p = new concrete_factory<ATL,CTL>;
	p->create( tag<A>() );
	p->create( tag<B>() );
	p->create( tag<C>() );
	return 0;
}
